Index: codes/icosagcm/trunk/src/diagnostics/check_conserve.f90
===================================================================
--- codes/icosagcm/trunk/src/diagnostics/check_conserve.f90	(revision 581)
+++ codes/icosagcm/trunk/src/diagnostics/check_conserve.f90	(revision 599)
@@ -299,5 +299,5 @@
     REAL(rstd),INTENT(INOUT) :: e, s, AAM_mass, AAM_vel, rmsv
     
-    REAL(rstd) :: ucenter(iim*jjm,3,llm)
+    REAL(rstd) :: ucenter(iim*jjm,llm,3)
     REAL(rstd) :: ulon(iim*jjm,llm)
     REAL(rstd) :: ulat(iim*jjm,llm)
Index: codes/icosagcm/trunk/src/diagnostics/diagflux.F90
===================================================================
--- codes/icosagcm/trunk/src/diagnostics/diagflux.F90	(revision 599)
+++ codes/icosagcm/trunk/src/diagnostics/diagflux.F90	(revision 599)
@@ -0,0 +1,160 @@
+MODULE diagflux_mod
+  USE icosa
+  USE omp_para
+  IMPLICIT NONE
+  SAVE
+  PRIVATE
+
+  TYPE(t_field), POINTER, PUBLIC :: &
+       f_masst(:), f_qmasst(:), & ! time-averaged mass, tracer mass, 
+       f_massfluxt(:), f_qfluxt(:), & ! time-integrated mass flux and tracer flux
+       f_qfluxt_lon(:), f_qfluxt_lat(:), & ! scalar flux reconstructed at cell centers
+       f_epot(:), f_ekin(:), f_enthalpy(:), & ! time-averaged potential E, kinetic E and enthalpy
+       f_epotfluxt(:), f_ekinfluxt(:), f_enthalpyfluxt(:) ! time averaged 'fluxes' of epot, ekin and enthalpy
+  LOGICAL :: diagflux_on
+  !$OMP THREADPRIVATE(diagflux_on)
+
+  PUBLIC :: diagflux_on, init_diagflux, zero_qfluxt, qflux_centered_lonlat, flux_centered_lonlat, diagflux_energy
+
+CONTAINS
+
+  SUBROUTINE init_diagflux
+    USE getin_mod
+    INTEGER :: ll
+    diagflux_on = .FALSE.
+    CALL getin("diagflux", diagflux_on)
+    ll = MERGE(llm,1,diagflux_on)
+    CALL allocate_field(f_masst,         field_t,type_real,ll,       name="masst")
+    CALL allocate_field(f_epot,          field_t,type_real,ll,       name="epot")
+    CALL allocate_field(f_ekin,          field_t,type_real,ll,       name="ekin")
+    CALL allocate_field(f_enthalpy,      field_t,type_real,ll,       name="enthalpy")
+    CALL allocate_field(f_qmasst,        field_t,type_real,ll,nqtot, name="qmasst")
+    CALL allocate_field(f_massfluxt,     field_u,type_real,ll,       name="massfluxt")
+    CALL allocate_field(f_epotfluxt,     field_u,type_real,ll,       name="epotfluxt")
+    CALL allocate_field(f_ekinfluxt,     field_u,type_real,ll,       name="ekinfluxt")
+    CALL allocate_field(f_enthalpyfluxt, field_u,type_real,ll,       name="enthalpyfluxt")
+    CALL allocate_field(f_qfluxt,        field_u,type_real,ll,nqtot, name="qfluxt")
+    CALL allocate_field(f_qfluxt_lon,    field_t,type_real,ll,nqtot, name="qfluxt_lon")
+    CALL allocate_field(f_qfluxt_lat,    field_t,type_real,ll,nqtot, name="qfluxt_lat")
+    IF(diagflux_on) CALL zero_qfluxt
+  END SUBROUTINE init_diagflux
+
+#define ZERO2(field) buf2=field(ind) ; buf2(:,ll_begin:ll_end)=0.
+#define ZERO3(field) buf3=field(ind) ; buf3(:,ll_begin:ll_end,:)=0.
+
+  SUBROUTINE zero_qfluxt
+    INTEGER :: ind
+    REAL(rstd), POINTER :: buf2(:,:),buf3(:,:,:)
+    DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
+       CALL swap_dimensions(ind)
+       ZERO2(f_masst)
+       ZERO2(f_epot)
+       ZERO2(f_ekin)
+       ZERO2(f_enthalpy)
+       ZERO3(f_qmasst)
+       ZERO2(f_massfluxt)
+       ZERO2(f_epotfluxt)
+       ZERO2(f_ekinfluxt)
+       ZERO2(f_enthalpyfluxt)
+       ZERO3(f_qfluxt)
+    END DO
+  END SUBROUTINE zero_qfluxt
+
+!------------------------------------ Reconstruct fluxes at cell centers ---------------------------------------
+
+  SUBROUTINE qflux_centered_lonlat(scale, f_flux, f_flux_lon, f_flux_lat)
+    REAL(rstd), INTENT(IN) :: scale
+    TYPE(t_field),POINTER :: f_flux(:), f_flux_lon(:), f_flux_lat(:)
+    REAL(rstd), POINTER :: flux(:,:,:), flux_lon(:,:,:), flux_lat(:,:,:)
+    INTEGER :: ind, itrac
+    DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
+       CALL swap_dimensions(ind)
+       CALL swap_geometry(ind)
+       flux=f_flux(ind)
+       flux_lon=f_flux_lon(ind)
+       flux_lat=f_flux_lat(ind)
+       DO itrac=1,nqtot
+          CALL compute_flux_centered_lonlat(scale, flux(:,:,itrac), flux_lon(:,:,itrac), flux_lat(:,:,itrac))
+       END DO
+    END DO
+  END SUBROUTINE qflux_centered_lonlat
+  
+  SUBROUTINE flux_centered_lonlat(scale, f_flux, f_flux_lon, f_flux_lat)
+    REAL(rstd), INTENT(IN) :: scale
+    TYPE(t_field),POINTER :: f_flux(:), f_flux_lon(:), f_flux_lat(:)
+    REAL(rstd), POINTER :: flux(:,:), flux_lon(:,:), flux_lat(:,:)
+    INTEGER :: ind
+    DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
+       CALL swap_dimensions(ind)
+       CALL swap_geometry(ind)
+       flux=f_flux(ind)
+       flux_lon=f_flux_lon(ind)
+       flux_lat=f_flux_lat(ind)
+       CALL compute_flux_centered_lonlat(scale, flux, flux_lon, flux_lat)
+    END DO
+  END SUBROUTINE flux_centered_lonlat
+  
+  SUBROUTINE compute_flux_centered_lonlat(scale, flux, flux_lon, flux_lat)
+    USE wind_mod
+    REAL(rstd), INTENT(IN) :: scale
+    REAL(rstd), INTENT(IN) :: flux(3*iim*jjm,llm)
+    REAL(rstd), INTENT(OUT) :: flux_lon(iim*jjm,llm), flux_lat(iim*jjm,llm)
+    REAL(rstd) :: flux_3d(iim*jjm,llm,3)
+    CALL compute_flux_centered(scale, flux, flux_3d)
+    CALL compute_wind_centered_lonlat_compound(flux_3d, flux_lon, flux_lat)
+  END SUBROUTINE compute_flux_centered_lonlat
+
+!------------------------------------ Compute energy fluxes ---------------------------------------
+
+  SUBROUTINE diagflux_energy(frac, f_phis,f_rhodz,f_theta_rhodz,f_u, f_geopot,f_theta, f_hfluxt)
+    REAL(rstd), INTENT(IN) :: frac
+    TYPE(t_field),POINTER :: f_phis(:),f_rhodz(:),f_theta_rhodz(:),f_u(:), f_geopot(:), f_theta(:), f_hfluxt(:)
+    REAL(rstd), POINTER :: phis(:), rhodz(:,:), theta_rhodz(:,:,:), u(:,:), &
+         geopot(:,:), pk(:,:,:), hfluxt(:,:), &
+         epot(:,:), ekin(:,:), enthalpy(:,:), &
+         epotflux(:,:), ekinflux(:,:), enthalpyflux(:,:)
+    INTEGER :: ind
+    DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
+       CALL swap_dimensions(ind)
+       CALL swap_geometry(ind)
+       hfluxt = f_hfluxt(ind)
+       phis = f_phis(ind)
+       rhodz = f_rhodz(ind)
+       theta_rhodz = f_theta_rhodz(ind)
+       u = f_u(ind)
+       geopot = f_geopot(ind)
+       pk = f_theta(ind) ! buffer
+       epot = f_epot(ind)
+       ekin = f_ekin(ind)
+       enthalpy = f_enthalpy(ind)
+       epotflux = f_epotfluxt(ind)
+       ekinflux = f_ekinfluxt(ind)
+       enthalpyflux = f_enthalpyfluxt(ind)
+       CALL compute_diagflux_energy(frac,hfluxt, phis,rhodz,theta_rhodz,u, geopot,pk, epot,ekin,enthalpy, epotflux, ekinflux, enthalpyflux)
+    END DO
+  END SUBROUTINE diagflux_energy
+
+  SUBROUTINE compute_diagflux_energy(frac, massflux, phis,rhodz,theta_rhodz,u, geopot,pk, epot,ekin,enthalpy, epot_flux, ekin_flux, enthalpy_flux)
+    USE disvert_mod, ONLY : ptop
+    REAL(rstd), INTENT(IN) :: frac
+    REAL(rstd), INTENT(IN) :: massflux(3*iim*jjm,llm), u(3*iim*jjm,llm),&
+                              phis(iim*jjm), rhodz(iim*jjm,llm), theta_rhodz(iim*jjm,llm,nqtot)
+    REAL(rstd), INTENT(INOUT) :: geopot(iim*jjm,llm+1), pk(iim*jjm,llm) ! pk = buffer
+    REAL(rstd), INTENT(INOUT), DIMENSION(iim*jjm, llm)   ::  epot, ekin, enthalpy
+    REAL(rstd), INTENT(INOUT), DIMENSION(3*iim*jjm, llm) ::  epot_flux, ekin_flux, enthalpy_flux    
+    REAL(rstd) :: energy, p_ik, theta_ik, temp_ik, gv, Rd 
+    INTEGER :: ij, l, ij_omp_begin_ext, ij_omp_end_ext
+    Rd = kappa*cpp
+    ! even if loops are of the _ext variant, we still need halo exchanges before reconstructing fluxes at cell centers
+    ! => loop over interior region
+    CALL distrib_level(ij_end-ij_begin+1,ij_omp_begin_ext,ij_omp_end_ext)
+    ij_omp_begin_ext = ij_omp_begin_ext+ij_begin-1
+    ij_omp_end_ext = ij_omp_end_ext+ij_begin-1
+#include "../kernels/energy_fluxes.k90"
+  END SUBROUTINE compute_diagflux_energy
+
+END MODULE diagflux_mod
Index: codes/icosagcm/trunk/src/diagnostics/observable.f90
===================================================================
--- codes/icosagcm/trunk/src/diagnostics/observable.f90	(revision 581)
+++ codes/icosagcm/trunk/src/diagnostics/observable.f90	(revision 599)
@@ -6,6 +6,5 @@
   TYPE(t_field),POINTER, SAVE :: f_buf_i(:), &
        f_buf_Fel(:), f_buf_uh(:), & ! horizontal velocity, different from prognostic velocity if NH
-       f_buf_ulon(:), f_buf_ulat(:), &
-       f_buf_u3d(:) ! unused, remove ?
+       f_buf_ulon(:), f_buf_ulat(:)
   TYPE(t_field),POINTER, SAVE :: f_buf1_i(:), f_buf2_i(:)
   TYPE(t_field),POINTER, SAVE :: f_buf_v(:), f_buf_s(:), f_buf_p(:)
@@ -24,5 +23,4 @@
     CALL allocate_field(f_buf2_i,   field_t,type_real,llm,name="buffer2_i")
     CALL allocate_field(f_buf_p,   field_t,type_real,llm+1) 
-    CALL allocate_field(f_buf_u3d, field_t,type_real,3,llm)  ! 3D vel at cell centers
     CALL allocate_field(f_buf_ulon,field_t,type_real,llm, name="buf_ulon")
     CALL allocate_field(f_buf_ulat,field_t,type_real,llm, name="buf_ulat")
@@ -49,4 +47,5 @@
     USE theta2theta_rhodz_mod
     USE omega_mod
+    USE diagflux_mod
     LOGICAL, INTENT(IN) :: init
     INTEGER :: l
@@ -160,4 +159,36 @@
     END IF
 
+    IF(.NOT. init) THEN
+       IF(diagflux_on) THEN
+          CALL flux_centered_lonlat(1./(itau_out*dt) , f_massfluxt, f_buf_ulon, f_buf_ulat)
+          CALL output_field("mass_t", f_masst)
+          CALL output_field("massflux_lon",f_buf_ulon)
+          CALL output_field("massflux_lat",f_buf_ulat)
+
+          CALL transfert_request(f_epotfluxt,req_e1_vect) 
+          CALL flux_centered_lonlat(1./(itau_out*dt) , f_epotfluxt, f_buf_ulon, f_buf_ulat)
+          CALL output_field("epot_t", f_epot)
+          CALL output_field("epotflux_lon",f_buf_ulon)
+          CALL output_field("epotflux_lat",f_buf_ulat)
+
+          CALL transfert_request(f_ekinfluxt,req_e1_vect) 
+          CALL flux_centered_lonlat(1./(itau_out*dt) , f_ekinfluxt, f_buf_ulon, f_buf_ulat)
+          CALL output_field("ekin_t", f_ekin)
+          CALL output_field("ekinflux_lon",f_buf_ulon)
+          CALL output_field("ekinflux_lat",f_buf_ulat)
+
+          CALL transfert_request(f_enthalpyfluxt,req_e1_vect) 
+          CALL flux_centered_lonlat(1./(itau_out*dt) , f_enthalpyfluxt, f_buf_ulon, f_buf_ulat)
+          CALL output_field("enthalpy_t", f_enthalpy)
+          CALL output_field("enthalpyflux_lon",f_buf_ulon)
+          CALL output_field("enthalpyflux_lat",f_buf_ulat)
+
+          CALL qflux_centered_lonlat(1./(itau_out*dt) , f_qfluxt, f_qfluxt_lon, f_qfluxt_lat)
+          CALL output_field("qmass_t", f_qmasst)
+          CALL output_field("qflux_lon",f_qfluxt_lon)
+          CALL output_field("qflux_lat",f_qfluxt_lat)
+          CALL zero_qfluxt  ! restart accumulating fluxes
+       END IF
+    END IF
   END SUBROUTINE write_output_fields_basic
   
Index: codes/icosagcm/trunk/src/diagnostics/wind.F90
===================================================================
--- codes/icosagcm/trunk/src/diagnostics/wind.F90	(revision 599)
+++ codes/icosagcm/trunk/src/diagnostics/wind.F90	(revision 599)
@@ -0,0 +1,355 @@
+MODULE wind_mod
+  USE omp_para
+  USE icosa
+  IMPLICIT NONE
+  PRIVATE
+
+  PUBLIC :: compute_wind_centered, compute_flux_centered, &
+       compute_wind_centered_lonlat_compound, compute_wind2d_perp_from_lonlat_compound, &
+       compute_wind_centered_from_lonlat_compound, compute_wind_perp_from_lonlat_compound, &
+       un2ulonlat, ulonlat2un
+       
+CONTAINS
+
+  SUBROUTINE un2ulonlat(f_u, f_ulon, f_ulat)
+    TYPE(t_field), POINTER :: f_u(:) ! IN  : normal velocity components on edges
+    TYPE(t_field), POINTER :: f_ulon(:), f_ulat(:) ! OUT : velocity reconstructed at hexagons    
+    REAL(rstd),POINTER :: u(:,:),  ulon(:,:), ulat(:,:)
+    INTEGER :: ind
+
+    DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
+       CALL swap_dimensions(ind)
+       CALL swap_geometry(ind)
+       u=f_u(ind)
+       ulon=f_ulon(ind)
+       ulat=f_ulat(ind)
+       CALL compute_un2ulonlat(u,ulon, ulat)
+    END DO
+
+  END SUBROUTINE un2ulonlat
+
+  SUBROUTINE ulonlat2un(f_ulon, f_ulat,f_u)
+    TYPE(t_field), POINTER :: f_ulon(:), f_ulat(:) ! IN : velocity reconstructed at hexagons
+    TYPE(t_field), POINTER :: f_u(:) ! OUT  : normal velocity components on edges
+    
+    REAL(rstd),POINTER :: u(:,:),  ulon(:,:), ulat(:,:)
+    INTEGER :: ind
+
+    DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
+       CALL swap_dimensions(ind)
+       CALL swap_geometry(ind)
+       u=f_u(ind)
+       ulon=f_ulon(ind)
+       ulat=f_ulat(ind)
+       CALL compute_ulonlat2un(ulon, ulat,u)
+    END DO
+
+  END SUBROUTINE ulonlat2un
+ 
+  SUBROUTINE compute_wind_centered(ue,ucenter)
+  REAL(rstd) :: ue(3*iim*jjm,llm)
+  REAL(rstd) :: ucenter(iim*jjm,llm,3)
+  INTEGER :: ij,l
+  REAL(rstd), PARAMETER :: scale=1.
+  REAL(rstd) :: fac, ue_le, cx,cy,cz, ux,uy,uz
+#include "../kernels/wind_centered.k90"
+ END SUBROUTINE compute_wind_centered
+ 
+  SUBROUTINE compute_flux_centered(scale,ue,ucenter)
+  REAL(rstd), INTENT(IN) :: scale
+  REAL(rstd) :: ue(3*iim*jjm,llm)
+  REAL(rstd) :: ucenter(iim*jjm,llm,3)
+  INTEGER :: ij,l
+  REAL(rstd) :: fac, ue_le, cx,cy,cz, ux,uy,uz
+#include "../kernels/flux_centered.k90"
+  END SUBROUTINE compute_flux_centered
+ 
+  
+ SUBROUTINE compute_wind_on_edge(ue,uedge)
+  REAL(rstd) :: ue(3*iim*jjm,llm)
+  REAL(rstd) :: uedge(3*iim*jjm,llm,3)
+
+  REAL(rstd) :: ut(3*iim*jjm,llm)
+  INTEGER :: i,j,ij,l     
+    
+    CALL compute_tangential_compound(ue,ut)
+  
+    DO l=ll_begin,ll_end
+      DO j=jj_begin,jj_end
+        DO i=ii_begin,ii_end
+          ij=(j-1)*iim+i
+          uedge(ij+u_right,l,:)=ue(ij+u_right,l)*ep_e(ij+u_right,:)*ne(ij,right) + ut(ij+u_right,l)*et_e(ij+u_right,:)*ne(ij,right) 
+          uedge(ij+u_lup,l,:)=ue(ij+u_lup,l)*ep_e(ij+u_lup,:)*ne(ij,lup) + ut(ij+u_lup,l)*et_e(ij+u_lup,:)*ne(ij,lup)
+          uedge(ij+u_ldown,l,:)=ue(ij+u_ldown,l)*ep_e(ij+u_ldown,:)*ne(ij,ldown) + ut(ij+u_ldown,l)*et_e(ij+u_ldown,:)*ne(ij,ldown)
+        ENDDO
+      ENDDO
+    ENDDO
+ 
+ END SUBROUTINE compute_wind_on_edge
+ 
+ 
+ 
+ SUBROUTINE compute_tangential_compound(ue,ut)
+  REAL(rstd) :: ue(3*iim*jjm,llm)
+  REAL(rstd) :: ut(3*iim*jjm,llm)
+  INTEGER :: i,j,l,ij
+    
+  DO l=ll_begin,ll_end
+    DO j=jj_begin,jj_end
+      DO i=ii_begin,ii_end
+        ij=(j-1)*iim+i
+   
+        ut(ij+u_right,l) = 1/de(ij+u_right) *                                            &  
+                         ( wee(ij+u_right,1,1)*ue(ij+u_rup,l)+                           &
+                           wee(ij+u_right,2,1)*ue(ij+u_lup,l)+                           &
+                           wee(ij+u_right,3,1)*ue(ij+u_left,l)+                          &
+                           wee(ij+u_right,4,1)*ue(ij+u_ldown,l)+                         &
+                           wee(ij+u_right,5,1)*ue(ij+u_rdown,l)+                         & 
+                           wee(ij+u_right,1,2)*ue(ij+t_right+u_ldown,l)+                 &
+                           wee(ij+u_right,2,2)*ue(ij+t_right+u_rdown,l)+                 &
+                           wee(ij+u_right,3,2)*ue(ij+t_right+u_right,l)+                 &
+                           wee(ij+u_right,4,2)*ue(ij+t_right+u_rup,l)+                   &
+                           wee(ij+u_right,5,2)*ue(ij+t_right+u_lup,l) )   
+     
+        ut(ij+u_lup,l) =  1/de(ij+u_lup) *                                           &  
+                         ( wee(ij+u_lup,1,1)*ue(ij+u_left,l)+                        &
+                           wee(ij+u_lup,2,1)*ue(ij+u_ldown,l)+                       &
+                           wee(ij+u_lup,3,1)*ue(ij+u_rdown,l)+                       &
+                           wee(ij+u_lup,4,1)*ue(ij+u_right,l)+                       &
+                           wee(ij+u_lup,5,1)*ue(ij+u_rup,l)+                         & 
+                           wee(ij+u_lup,1,2)*ue(ij+t_lup+u_right,l)+                 &
+                           wee(ij+u_lup,2,2)*ue(ij+t_lup+u_rup,l)+                   &
+                           wee(ij+u_lup,3,2)*ue(ij+t_lup+u_lup,l)+                   &
+                           wee(ij+u_lup,4,2)*ue(ij+t_lup+u_left,l)+                  &
+                           wee(ij+u_lup,5,2)*ue(ij+t_lup+u_ldown,l) )
+
+    
+        ut(ij+u_ldown,l) = 1/de(ij+u_ldown) *   &  
+                         ( wee(ij+u_ldown,1,1)*ue(ij+u_rdown,l)+                      &
+                           wee(ij+u_ldown,2,1)*ue(ij+u_right,l)+                      &
+                           wee(ij+u_ldown,3,1)*ue(ij+u_rup,l)+                        &
+                           wee(ij+u_ldown,4,1)*ue(ij+u_lup,l)+                        &
+                           wee(ij+u_ldown,5,1)*ue(ij+u_left,l)+                       & 
+                           wee(ij+u_ldown,1,2)*ue(ij+t_ldown+u_lup,l)+                &
+                           wee(ij+u_ldown,2,2)*ue(ij+t_ldown+u_left,l)+               &
+                           wee(ij+u_ldown,3,2)*ue(ij+t_ldown+u_ldown,l)+              &
+                           wee(ij+u_ldown,4,2)*ue(ij+t_ldown+u_rdown,l)+              &
+                           wee(ij+u_ldown,5,2)*ue(ij+t_ldown+u_right,l) )  
+        
+        ENDDO
+      ENDDO
+    ENDDO
+                        
+ END SUBROUTINE compute_tangential_compound
+ 
+! SUBROUTINE compute_wind_lonlat_compound(u, ulon, ulat)
+!  REAL(rstd) :: u(3*iim*jjm,3,llm)
+!  REAL(rstd) :: ulon(3*iim*jjm,3,llm)
+!  REAL(rstd) :: ulat(3*iim*jjm,3,llm)
+!
+!  INTEGER :: i,j,ij,l     
+!    
+!  
+!    DO l=ll_begin,ll_end
+!      DO j=jj_begin-1,jj_end+1
+!        DO i=ii_begin-1,ii_end+1
+!          ij=(j-1)*iim+i
+!          ulon(ij+u_right,:,l)=sum(u(ij+u_right,:,l)*elon_e(ij+u_right,:))*elon_e(ij+u_right,:) 
+!          ulon(ij+u_lup,:,l)=sum(u(ij+u_lup,:,l)*elon_e(ij+u_lup,:))*elon_e(ij+u_lup,:)
+!          ulon(ij+u_ldown,:,l)=sum(u(ij+u_ldown,:,l)*elon_e(ij+u_ldown,:))*elon_e(ij+u_ldown,:)
+!          
+!          ulat(ij+u_right,:,l)=sum(u(ij+u_right,:,l)*elat_e(ij+u_right,:))*elat_e(ij+u_right,:) 
+!          ulat(ij+u_lup,:,l)=sum(u(ij+u_lup,:,l)*elat_e(ij+u_lup,:))*elat_e(ij+u_lup,:) 
+!          ulat(ij+u_ldown,:,l)=sum(u(ij+u_ldown,:,l)*elat_e(ij+u_ldown,:))*elat_e(ij+u_ldown,:) 
+!          
+!        ENDDO
+!      ENDDO
+!    ENDDO
+! 
+! END SUBROUTINE compute_wind_lonlat_compound
+ 
+  SUBROUTINE compute_wind_from_lonlat_compound(ulon, ulat, u)
+  REAL(rstd) :: u(3*iim*jjm,llm,3)
+  REAL(rstd) :: ulon(3*iim*jjm,llm)
+  REAL(rstd) :: ulat(3*iim*jjm,llm)
+
+  INTEGER :: i,j,ij,l     
+  
+    DO l=ll_begin,ll_end
+      DO j=jj_begin-1,jj_end+1
+        DO i=ii_begin-1,ii_end+1
+          ij=(j-1)*iim+i
+          u(ij+u_right,l,:)=ulon(ij+u_right,l)*elon_e(ij+u_right,:)+ ulat(ij+u_right,l)*elat_e(ij+u_right,:)
+          u(ij+u_lup,l,:)=ulon(ij+u_lup,l)*elon_e(ij+u_lup,:) + ulat(ij+u_lup,l)*elat_e(ij+u_lup,:)
+          u(ij+u_ldown,l,:)=ulon(ij+u_ldown,l)*elon_e(ij+u_ldown,:) + ulat(ij+u_ldown,l)*elat_e(ij+u_ldown,:)
+        ENDDO
+      ENDDO
+    ENDDO
+ 
+  END SUBROUTINE compute_wind_from_lonlat_compound
+ 
+  SUBROUTINE compute_wind_centered_from_lonlat_compound(ulon, ulat, u)
+  REAL(rstd) :: u(iim*jjm,llm,3)
+  REAL(rstd) :: ulon(iim*jjm,llm)
+  REAL(rstd) :: ulat(iim*jjm,llm)
+  INTEGER :: i,j,ij,l     
+  DO l=ll_begin,ll_end
+      DO j=jj_begin-1,jj_end+1
+        DO i=ii_begin-1,ii_end+1
+          ij=(j-1)*iim+i
+          u(ij,l,:)=ulon(ij,l)*elon_i(ij,:)+ ulat(ij,l)*elat_i(ij,:)
+        ENDDO
+      ENDDO
+    ENDDO 
+  END SUBROUTINE compute_wind_centered_from_lonlat_compound
+ 
+  SUBROUTINE compute_wind2D_from_lonlat_compound(ulon, ulat, u)
+  REAL(rstd) :: u(3*iim*jjm,3)
+  REAL(rstd) :: ulon(3*iim*jjm)
+  REAL(rstd) :: ulat(3*iim*jjm)
+  
+  INTEGER :: i,j,ij
+  
+  DO j=jj_begin-1,jj_end+1
+     DO i=ii_begin-1,ii_end+1
+        ij=(j-1)*iim+i
+        u(ij+u_right,:)=ulon(ij+u_right)*elon_e(ij+u_right,:)+ ulat(ij+u_right)*elat_e(ij+u_right,:)
+        u(ij+u_lup,:)=ulon(ij+u_lup)*elon_e(ij+u_lup,:) + ulat(ij+u_lup)*elat_e(ij+u_lup,:)
+        u(ij+u_ldown,:)=ulon(ij+u_ldown)*elon_e(ij+u_ldown,:) + ulat(ij+u_ldown)*elat_e(ij+u_ldown,:)
+     ENDDO
+  ENDDO
+    
+  END SUBROUTINE compute_wind2D_from_lonlat_compound
+ 
+  SUBROUTINE compute_wind_perp_from_lonlat_compound(ulon, ulat, up)
+  REAL(rstd) :: up(3*iim*jjm,llm)
+  REAL(rstd) :: ulon(3*iim*jjm,llm)
+  REAL(rstd) :: ulat(3*iim*jjm,llm)
+  REAL(rstd) :: u(3*iim*jjm,llm,3)
+
+  INTEGER :: i,j,ij,l     
+  
+   CALL compute_wind_from_lonlat_compound(ulon, ulat, u)
+
+    DO l=ll_begin,ll_end
+      DO j=jj_begin-1,jj_end+1
+        DO i=ii_begin-1,ii_end+1
+          ij=(j-1)*iim+i
+          up(ij+u_right,l)=sum(u(ij+u_right,l,:)*ep_e(ij+u_right,:))
+          up(ij+u_lup,l)=sum(u(ij+u_lup,l,:)*ep_e(ij+u_lup,:))
+          up(ij+u_ldown,l)=sum(u(ij+u_ldown,l,:)*ep_e(ij+u_ldown,:))
+        ENDDO
+      ENDDO
+    ENDDO
+ 
+  END SUBROUTINE compute_wind_perp_from_lonlat_compound
+   
+  SUBROUTINE compute_wind2D_perp_from_lonlat_compound(ulon, ulat, up)
+  REAL(rstd) :: up(3*iim*jjm)
+  REAL(rstd) :: ulon(3*iim*jjm)
+  REAL(rstd) :: ulat(3*iim*jjm)
+  REAL(rstd) :: u(3*iim*jjm,3)
+
+  INTEGER :: i,j,ij 
+  
+  CALL compute_wind2D_from_lonlat_compound(ulon, ulat, u)
+  DO j=jj_begin-1,jj_end+1
+     DO i=ii_begin-1,ii_end+1
+        ij=(j-1)*iim+i
+        up(ij+u_right)=sum(u(ij+u_right,:)*ep_e(ij+u_right,:))
+        up(ij+u_lup)=sum(u(ij+u_lup,:)*ep_e(ij+u_lup,:))
+        up(ij+u_ldown)=sum(u(ij+u_ldown,:)*ep_e(ij+u_ldown,:))
+     ENDDO
+  ENDDO
+   
+  END SUBROUTINE compute_wind2D_perp_from_lonlat_compound
+   
+ SUBROUTINE compute_wind_centered_lonlat_compound(uc, ulon, ulat)
+  REAL(rstd) :: uc(iim*jjm,llm,3)
+  REAL(rstd) :: ulon(iim*jjm,llm)
+  REAL(rstd) :: ulat(iim*jjm,llm)
+
+  INTEGER :: i,j,ij,l     
+  
+    DO l=ll_begin,ll_end
+      DO j=jj_begin,jj_end
+        DO i=ii_begin,ii_end
+          ij=(j-1)*iim+i
+          ulon(ij,l)=sum(uc(ij,l,:)*elon_i(ij,:))
+          ulat(ij,l)=sum(uc(ij,l,:)*elat_i(ij,:)) 
+        ENDDO
+      ENDDO
+    ENDDO
+ 
+ END SUBROUTINE compute_wind_centered_lonlat_compound
+
+ SUBROUTINE compute_wind_centered_from_wind_lonlat_centered(ulon, ulat,uc)
+  REAL(rstd) :: ulon(iim*jjm,llm)
+  REAL(rstd) :: ulat(iim*jjm,llm)
+  REAL(rstd) :: uc(iim*jjm,llm,3)
+
+  INTEGER :: i,j,ij,l     
+    
+  
+    DO l=ll_begin,ll_end
+      DO j=jj_begin,jj_end
+        DO i=ii_begin,ii_end
+          ij=(j-1)*iim+i
+          uc(ij,l,:)=ulon(ij,l)*elon_i(ij,:)+ulat(ij,l)*elat_i(ij,:)
+        ENDDO
+      ENDDO
+    ENDDO
+ 
+ END SUBROUTINE compute_wind_centered_from_wind_lonlat_centered
+
+ SUBROUTINE compute_wind_perp_from_wind_centered(uc,un)
+
+  IMPLICIT NONE
+  REAL(rstd),INTENT(IN)   :: uc(iim*jjm,llm,3)
+  REAL(rstd),INTENT(OUT)  :: un(3*iim*jjm,llm)
+
+  INTEGER :: i,j,ij,l     
+    
+  
+    DO l=ll_begin,ll_end
+      DO j=jj_begin,jj_end
+        DO i=ii_begin,ii_end
+          ij=(j-1)*iim+i
+          un(ij+u_right,l) = sum(0.5*(uc(ij,l,:) + uc(ij+t_right,l,:))*ep_e(ij+u_right,:))
+          un(ij+u_lup,l) = sum(0.5*(uc(ij,l,:) + uc(ij+t_lup,l,:))*ep_e(ij+u_lup,:))
+          un(ij+u_ldown,l) = sum(0.5*(uc(ij,l,:) + uc(ij+t_ldown,l,:))*ep_e(ij+u_ldown,:))
+         ENDDO
+      ENDDO
+    ENDDO
+ 
+ END SUBROUTINE compute_wind_perp_from_wind_centered
+
+
+ SUBROUTINE compute_un2ulonlat(un, ulon, ulat)
+  REAL(rstd),INTENT(IN)  :: un(3*iim*jjm,llm)
+  REAL(rstd),INTENT(OUT) :: ulon(iim*jjm,llm)
+  REAL(rstd),INTENT(OUT) :: ulat(iim*jjm,llm)
+
+  REAL(rstd)             :: uc(iim*jjm,llm,3)
+    
+  CALL compute_wind_centered(un,uc)  
+  CALL compute_wind_centered_lonlat_compound(uc, ulon, ulat)
+ 
+ END SUBROUTINE compute_un2ulonlat
+
+ SUBROUTINE compute_ulonlat2un(ulon, ulat,un)
+  REAL(rstd),INTENT(IN) :: ulon(iim*jjm,llm)
+  REAL(rstd),INTENT(IN) :: ulat(iim*jjm,llm)
+  REAL(rstd),INTENT(OUT)  :: un(3*iim*jjm,llm)
+
+  REAL(rstd)             :: uc(iim*jjm,llm,3)
+    
+    CALL compute_wind_centered_from_wind_lonlat_centered(ulon, ulat, uc)  
+    CALL compute_wind_perp_from_wind_centered(uc, un)
+ 
+ END SUBROUTINE compute_ulonlat2un
+
+
+END MODULE wind_mod
Index: codes/icosagcm/trunk/src/dynamics/caldyn_gcm.F90
===================================================================
--- codes/icosagcm/trunk/src/dynamics/caldyn_gcm.F90	(revision 581)
+++ codes/icosagcm/trunk/src/dynamics/caldyn_gcm.F90	(revision 599)
@@ -5,4 +5,6 @@
   USE caldyn_kernels_base_mod
   USE caldyn_kernels_mod
+  USE omp_para
+  USE mpipara
   IMPLICIT NONE
   PRIVATE
@@ -13,9 +15,4 @@
   
   SUBROUTINE init_caldyn
-    USE icosa
-    USE observable_mod
-    USE mpipara
-    USE omp_para
-    IMPLICIT NONE
     CHARACTER(len=255) :: def
     INTEGER            :: ind
@@ -124,7 +121,4 @@
 
   SUBROUTINE allocate_caldyn
-  USE icosa
-  IMPLICIT NONE
-
     CALL allocate_field(f_out_u,field_u,type_real,llm) 
     CALL allocate_field(f_qu,field_u,type_real,llm) 
@@ -142,7 +136,4 @@
 
   SUBROUTINE caldyn_BC(f_phis, f_geopot, f_wflux)
-    USE icosa
-    USE mpipara
-    USE omp_para
     TYPE(t_field),POINTER :: f_phis(:)
     TYPE(t_field),POINTER :: f_geopot(:)
@@ -186,17 +177,7 @@
   SUBROUTINE caldyn(write_out,f_phis, f_ps, f_mass, f_theta_rhodz, f_u, f_q, &
        f_geopot, f_hflux, f_wflux, f_dps, f_dmass, f_dtheta_rhodz, f_du)
-    USE icosa
     USE observable_mod
     USE disvert_mod, ONLY : caldyn_eta, eta_mass
-    USE vorticity_mod
-    USE kinetic_mod
-    USE theta2theta_rhodz_mod
-    USE wind_mod
-    USE mpipara
     USE trace
-    USE omp_para
-    USE output_field_mod
-    USE checksum_mod
-    IMPLICIT NONE
     LOGICAL,INTENT(IN)    :: write_out
     TYPE(t_field),POINTER :: f_phis(:)
@@ -375,7 +356,4 @@
 
   SUBROUTINE check_mass_conservation(f_ps,f_dps)
-  USE icosa
-  USE mpipara
-  IMPLICIT NONE
     TYPE(t_field),POINTER :: f_ps(:)
     TYPE(t_field),POINTER :: f_dps(:)
Index: codes/icosagcm/trunk/src/icosa_init.f90
===================================================================
--- codes/icosagcm/trunk/src/icosa_init.f90	(revision 581)
+++ codes/icosagcm/trunk/src/icosa_init.f90	(revision 599)
@@ -1,5 +1,3 @@
 MODULE icosa_init_mod
-
-
 
 CONTAINS
@@ -22,4 +20,5 @@
   USE restart_mod
   USE etat0_mod
+  USE diagflux_mod
   IMPLICIT NONE
   
@@ -55,5 +54,6 @@
     CALL init_timeloop
     CALL init_physics
-   
+
+    CALL init_diagflux
     CALL timeloop
     CALL switch_omp_no_distrib_level
Index: codes/icosagcm/trunk/src/kernels/advect_horiz.k90
===================================================================
--- codes/icosagcm/trunk/src/kernels/advect_horiz.k90	(revision 599)
+++ codes/icosagcm/trunk/src/kernels/advect_horiz.k90	(revision 599)
@@ -0,0 +1,74 @@
+   !--------------------------------------------------------------------------
+   !---------------------------- advect_horiz ----------------------------------
+   ! evaluate tracer field at point cc using piecewise linear reconstruction
+   ! q(cc)= q0 + gradq.(cc-xyz_i) with xi centroid of hexagon
+   ! sign*hfluxt>0 iff outgoing
+   DO l = ll_begin, ll_end
+      !DIR$ SIMD
+      DO ij=ij_begin_ext, ij_end_ext
+         IF(ne_right*hfluxt(ij+u_right,l)>0.) THEN
+            qe = qi(ij,l)
+            qe = qe + (cc(ij+u_right,l,1)-xyz_i(ij,1))*gradq3d(ij,l,1)
+            qe = qe + (cc(ij+u_right,l,2)-xyz_i(ij,2))*gradq3d(ij,l,2)
+            qe = qe + (cc(ij+u_right,l,3)-xyz_i(ij,3))*gradq3d(ij,l,3)
+         ELSE
+            qe = qi(ij+t_right,l)
+            qe = qe + (cc(ij+u_right,l,1)-xyz_i(ij+t_right,1))*gradq3d(ij+t_right,l,1)
+            qe = qe + (cc(ij+u_right,l,2)-xyz_i(ij+t_right,2))*gradq3d(ij+t_right,l,2)
+            qe = qe + (cc(ij+u_right,l,3)-xyz_i(ij+t_right,3))*gradq3d(ij+t_right,l,3)
+         END IF
+         qflux(ij+u_right,l) = hfluxt(ij+u_right,l)*qe
+         IF(diagflux_on) qfluxt(ij+u_right,l) = qfluxt(ij+u_right,l)+qflux(ij+u_right,l)
+         IF(ne_lup*hfluxt(ij+u_lup,l)>0.) THEN
+            qe = qi(ij,l)
+            qe = qe + (cc(ij+u_lup,l,1)-xyz_i(ij,1))*gradq3d(ij,l,1)
+            qe = qe + (cc(ij+u_lup,l,2)-xyz_i(ij,2))*gradq3d(ij,l,2)
+            qe = qe + (cc(ij+u_lup,l,3)-xyz_i(ij,3))*gradq3d(ij,l,3)
+         ELSE
+            qe = qi(ij+t_lup,l)
+            qe = qe + (cc(ij+u_lup,l,1)-xyz_i(ij+t_lup,1))*gradq3d(ij+t_lup,l,1)
+            qe = qe + (cc(ij+u_lup,l,2)-xyz_i(ij+t_lup,2))*gradq3d(ij+t_lup,l,2)
+            qe = qe + (cc(ij+u_lup,l,3)-xyz_i(ij+t_lup,3))*gradq3d(ij+t_lup,l,3)
+         END IF
+         qflux(ij+u_lup,l) = hfluxt(ij+u_lup,l)*qe
+         IF(diagflux_on) qfluxt(ij+u_lup,l) = qfluxt(ij+u_lup,l)+qflux(ij+u_lup,l)
+         IF(ne_ldown*hfluxt(ij+u_ldown,l)>0.) THEN
+            qe = qi(ij,l)
+            qe = qe + (cc(ij+u_ldown,l,1)-xyz_i(ij,1))*gradq3d(ij,l,1)
+            qe = qe + (cc(ij+u_ldown,l,2)-xyz_i(ij,2))*gradq3d(ij,l,2)
+            qe = qe + (cc(ij+u_ldown,l,3)-xyz_i(ij,3))*gradq3d(ij,l,3)
+         ELSE
+            qe = qi(ij+t_ldown,l)
+            qe = qe + (cc(ij+u_ldown,l,1)-xyz_i(ij+t_ldown,1))*gradq3d(ij+t_ldown,l,1)
+            qe = qe + (cc(ij+u_ldown,l,2)-xyz_i(ij+t_ldown,2))*gradq3d(ij+t_ldown,l,2)
+            qe = qe + (cc(ij+u_ldown,l,3)-xyz_i(ij+t_ldown,3))*gradq3d(ij+t_ldown,l,3)
+         END IF
+         qflux(ij+u_ldown,l) = hfluxt(ij+u_ldown,l)*qe
+         IF(diagflux_on) qfluxt(ij+u_ldown,l) = qfluxt(ij+u_ldown,l)+qflux(ij+u_ldown,l)
+      END DO
+   END DO
+   ! update q and, if update_mass, update mass
+   DO l = ll_begin, ll_end
+      !DIR$ SIMD
+      DO ij=ij_begin, ij_end
+         dmass=0.
+         dq=0.
+         dmass = dmass + ne_rup*hfluxt(ij+u_rup,l)
+         dq = dq + ne_rup*qflux(ij+u_rup,l)
+         dmass = dmass + ne_lup*hfluxt(ij+u_lup,l)
+         dq = dq + ne_lup*qflux(ij+u_lup,l)
+         dmass = dmass + ne_left*hfluxt(ij+u_left,l)
+         dq = dq + ne_left*qflux(ij+u_left,l)
+         dmass = dmass + ne_ldown*hfluxt(ij+u_ldown,l)
+         dq = dq + ne_ldown*qflux(ij+u_ldown,l)
+         dmass = dmass + ne_rdown*hfluxt(ij+u_rdown,l)
+         dq = dq + ne_rdown*qflux(ij+u_rdown,l)
+         dmass = dmass + ne_right*hfluxt(ij+u_right,l)
+         dq = dq + ne_right*qflux(ij+u_right,l)
+         newmass = mass(ij,l) - dmass/Ai(ij)
+         qi(ij,l) = (qi(ij,l)*mass(ij,l)-dq/Ai(ij)) / newmass
+         IF(update_mass) mass(ij,l)=newmass
+      END DO
+   END DO
+   !---------------------------- advect_horiz ----------------------------------
+   !--------------------------------------------------------------------------
